// Copyright (c) 2024-2026 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// operator-join.go
package expr

import (
	"fmt"
	"io"

	"git.portale-stac.it/go-pkg/expr/kern"
	"git.portale-stac.it/go-pkg/expr/scan"
)

//-------- join term

func newJoinTerm(tk *scan.Token) (inst *scan.Term) {
	return &scan.Term{
		Tk:       *tk,
		Children: make([]*scan.Term, 0, 2),
		Position: scan.PosInfix,
		Priority: scan.PriIterOp,
		EvalFunc: evalJoin,
	}
}

func evalJoin(ctx kern.ExprContext, opTerm *scan.Term) (v any, err error) {
	var leftValue, rightValue any
	var itLeft, itRight kern.Iterator
	var item any
	var ok bool

	if err = opTerm.CheckOperands(); err != nil {
		return
	}

	if leftValue, err = opTerm.Children[0].Compute(ctx); err != nil {
		return
	}

	if rightValue, err = opTerm.Children[1].Compute(ctx); err != nil {
		return
	}

	if itLeft, ok = leftValue.(kern.Iterator); !ok {
		if itLeft, err = NewIterator(ctx, leftValue, nil); err != nil {
			return nil, fmt.Errorf("left operand of JOIN must be an iterable data-source; got %s", kern.TypeName(leftValue))
		}
	}

	if itRight, ok = rightValue.(kern.Iterator); !ok {
		if itRight, err = NewIterator(ctx, rightValue, nil); err != nil {
			return nil, fmt.Errorf("right operand of JOIN must be an iterable data-source; got %s", kern.TypeName(rightValue))
		}
	}

	values := kern.NewListA()
	for _, it := range []kern.Iterator{itLeft, itRight} {
		for item, err = it.Next(); err == nil; item, err = it.Next() {
			values.AppendItem(item)
		}
	}
	if err == io.EOF {
		err = nil
	}
	v = values
	return
}

// init
func init() {
	scan.RegisterTermConstructor(scan.SymKwJoin, newJoinTerm)
}
